/**
 * @module GMap
 * @type class
 * @extends Map
 */
export declare class GMap<K, V> extends Map<K, V> {
    /**
     * @title array
     * @description 静态方法
     * @param map 接收GMap或者Map类型
     * @returns {key,value}[]
     */
    static array<Key, Value>(map: GMap<Key, Value> | Map<Key, Value>): {
        key: Key;
        value: Value;
    }[];
    /**
     * @title getKeys
     * @description 静态方法
     * @param map 接收GMap或者Map类型
     * @returns key[]
     */
    static getKeys<Key, Value>(map: GMap<Key, Value> | Map<Key, Value>): Key[];
    /**
     * @title getKeys
     * @returns key[]
     */
    getKeys(): K[];
    /**
     * @title getValues
     * @returns value[]
     */
    getValues(): V[];
    /**
     * @title getEntrues
     * @returns <[key,value]>[]
     */
    getEntries(): [K, V][];
    /**
     * @title map
     * @param callback (value,key,index)=>T
     * @returns T[]
     */
    map<R>(fn: (v: V, k: K, i: number) => R): R[];
    /**
     * @title filter
     * @param callback (value,key,index)=>boolean
     * @returns value[]
     */
    filter(fn: (v: V, k: K, i: number) => boolean): V[];
}
