/**
 * @module GMath
 * @type class
 * @description 注意！该类下的方法皆为静态方法
 */
export declare class GMath {
    /**
     * @title randomLenNum
     * @description 随机长度数字
     * @param length
     * @param isNumber
     * @returns string|number
     */
    static randomLenNum(length?: number, isNumber?: boolean): string | number;
    /**
     * @title randomStr
     * @description 随机字符串
     * @returns string
     */
    static randomStr(): string;
    /**
     * @title randomBoolean
     * @description 随机布尔值
     * @param float
     * @returns boolean
     */
    static randomBoolean(float?: number): boolean;
    /**
     * @title randomRange
     * @description 随机数字范围
     * @param min
     * @param max
     * @param float
     * @returns number
     */
    static randomRange(min: number, max: number, float?: number): number;
    /**
     * @title randomArray
     * @description 随机返回数组中的一项
     * @param arr T[]
     * @returns T
     */
    static randomArray<T>(arr: T[]): T;
    /**
     * @title randomLength
     * @description 随机长度范围内的整值（多适用于随机取数组索引）
     * @param length
     * @returns number
     */
    static randomLength(length: number): number;
    /**
     * @title precision
     * @description 精度控制
     * @param num 浮点数
     * @param precision 精度 默认=2 保留2位小数
     * @returns number
     */
    static precision(num: number, precision?: number): number;
    /**
     * @title between
     * @description 判断两数或日期之间
     * @param source  T 判断目标 可以是number|string|Date
     * @param target  T[]判断范围
     * @param border 是否含边界 默认false 含左侧
     * @returns boolean
     */
    static between(source: number | string | Date, target: (number | string | Date)[], border?: boolean): boolean;
}
