/**
 * @title useGStore
 * @description 直接使用，传入命名空间，会查找或创建并返回对应实例
 * @param namespaced string
 * @returns GStorage
 */
declare function useGStore(namespaced?: string): GStorage | undefined;
declare class GStorage {
    namespaced: string;
    state: object;
    constructor(namespaced: string);
    /**
     * @title init
     * @description 实例方法 初始化 自动调用
     */
    init(): void;
    /**
     * @title saveState
     * @description 实例方法 保存当前命名空间本地存储信息 自动调用
     */
    saveState(): void;
    /**
     * @title setItem
     * @description 存储字段名对应的内容信息
     * @param key
     * @param data
     * @returns state 整个store对象
     */
    setItem(key: string | number, data: any): object;
    /**
     * @title getItem
     * @description 获取字段名对应的内容信息
     * @param key
     * @returns value store中key对应的值
     */
    getItem(key: string | number): any;
    /**
     * @title removeItem
     * @description 删除字段名对应的内容信息
     * @param key
     * @returns state 整个store对象
     */
    removeItem(key: any): object;
    setState(): void;
    /**
     * @title clear
     * @description 清除当前命名空间
     */
    clear(): void;
}
export { useGStore, GStorage };
