/**
 * @module gType
 * @type function tools
 */
/**
 * @title isType
 * @description 判断类型的基础方法 柯里化函数
 * @param type string 类型字符串
 * @param val 判断的值
 * @returns boolean
 * @example isType('String')('测试用例');
 */
declare const isType: <T = any>(type: string) => (val: T) => boolean;
/**
 * @title isObject
 * @param val
 * @returns boolean
 */
declare const isObject: (val: object) => boolean;
/**
 * @title isEmptyObject
 * @param val
 * @returns boolean
 */
declare const isEmptyObject: (val: object) => boolean;
/**
 * @title isArray
 * @param val
 * @returns boolean
 */
declare const isArray: (val: any[]) => boolean;
/**
 * @title isArguments
 * @param val
 * @returns boolean
 */
declare const isArguments: (val: any) => boolean;
/**
 * @title isNull
 * @param val
 * @returns boolean
 */
declare const isNull: (val: any) => boolean;
/**
 * @title isNumber
 * @param val
 * @returns boolean
 */
declare const isNumber: (val: any) => boolean;
/**
 * @title isString
 * @param val
 * @returns boolean
 */
declare const isString: (val: any) => boolean;
/**
 * @title isBoolean
 * @param val
 * @returns boolean
 */
declare const isBoolean: (val: any) => boolean;
/**
 * @title isFunction
 * @param val
 * @returns boolean
 */
declare const isFunction: (val: any) => boolean;
/**
 * @title isPromise
 * @param val
 * @returns boolean
 */
declare const isPromise: (val: any) => boolean;
/**
 * @title isDate
 * @param val
 * @returns boolean
 */
declare const isDate: (val: any) => boolean;
/**
 * @title isRegExp
 * @param val
 * @returns boolean
 */
declare const isRegExp: (val: any) => boolean;
/**
 * @title isMap
 * @param val
 * @returns boolean
 */
declare const isMap: (val: any) => boolean;
/**
 * @title isSet
 * @param val
 * @returns boolean
 */
declare const isSet: (val: any) => boolean;
/**
 * @title isSymbol
 * @param val
 * @returns boolean
 */
declare const isSymbol: (val: any) => boolean;
/**
 * @title isError
 * @param val
 * @returns boolean
 */
declare const isError: (val: any) => boolean;
/**
 * @title isUndefined
 * @param val
 * @returns boolean
 */
declare const isUndefined: (val: any) => boolean;
/**
 * @title isEmpty
 * @param val
 * @returns boolean
 */
declare const isEmpty: (val?: null | undefined) => boolean;
/**
 * @title isNaN
 * @param val
 * @returns boolean
 */
declare const isNaN: (val: number) => boolean;
/**
 * @title isElement
 * @param val
 * @returns boolean
 */
declare const isElement: (val: HTMLElement) => boolean;
export { isType, isObject, isEmpty, isEmptyObject, isArray, isArguments, isNull, isNumber, isString, isBoolean, isFunction, isPromise, isDate, isRegExp, isMap, isSet, isSymbol, isError, isUndefined, isNaN, isElement, };
